/*
 * Example Code for the Paper
 *
 * "Mesh Saliency via Local Curvature Entropy", Eurographics 2016
 *
 * by M. Limper, A. Kuijper and D. Fellner
 *
 */

#ifndef LCE_TRI_MESH_H
#define LCE_TRI_MESH_H


#include <list>

//OpenMesh IO needs to be included before including a mesh type
#include <OpenMesh/Core/IO/MeshIO.hh>
#include <OpenMesh/Core/Mesh/PolyMesh_ArrayKernelT.hh>

#include "FloatHistogram.h"


namespace lce
{

//------------------------------------------------------------------------------------------------------------------

struct DefaultMeshTraitsLCE
{
  // OpenMesh default
  typedef OpenMesh::Vec3f  Point;

  // OpenMesh default
  typedef OpenMesh::Vec3f  Normal;

  // OpenMesh default
  typedef float  TexCoord1D;

  // use higher precision for texture coordinates
  typedef OpenMesh::Vec2d  TexCoord2D;

  // OpenMesh default
  typedef OpenMesh::Vec3f  TexCoord3D;

  // OpenMesh default
  typedef int TextureIndex;

  // OpenMesh default
  typedef OpenMesh::Vec3uc Color;

#ifndef DOXY_IGNORE_THIS
  VertexTraits    {};
  HalfedgeTraits  {};
  EdgeTraits      {};
  FaceTraits      {};
#endif

  VertexAttributes(0);
  HalfedgeAttributes(OpenMesh::Attributes::PrevHalfedge);
  EdgeAttributes(0);
  FaceAttributes(0);
};

//------------------------------------------------------------------------------------------------------------------

struct TriMesh : public OpenMesh::PolyMesh_ArrayKernelT<DefaultMeshTraitsLCE>
{
};

//------------------------------------------------------------------------------------------------------------------

} //namespace lce


#endif //LCE_TRI_MESH_H
